%% Also using the image blocks for calculate the balancing factor of noise between sub-swath.
% 1)along the inter-swath boundary, dividing two sub-swaths into blocks, and calculate balancing factor in each two adjacent blocks.
% 2)use the variance factor to select the homogeneous blocks, then use the balancing factor of the homogeneous blocks to calculate the mean balancing factor.
% 3)global sigma field regression.
% For details of explanation, please refer to Section III, Part B "Determination of power balancing Factor" in the paper by Sun and Li (2020)
%% Subtract the scaled additive noise
close all;
sigma_n_Scaled=zeros(size(Sigma_SN));
sWnum=length(firstAzimuthLine(:,1)); %the number of sub-swath
for count=1:sWnum %use kns in each scene in each sub-swath
    firstAzimuthLineEW=firstAzimuthLine(count,:);
    firstAzimuthLineEW(find(isnan(firstAzimuthLineEW)))=[]; 
    for ii=1:length(firstAzimuthLineEW) 
        nyy=firstRangeSample(count,ii):lastRangeSample(count,ii); %the range width of the scene
        nxx=firstAzimuthLine(count,ii):lastAzimuthLine(count,ii); %the azimuth width of the scene
        % SigmaScaled(nxx,nyy)=kns2(count).*gggDS(nxx,nyy).*rsNoise(nxx,nyy)./cali(nxx,nyy).^2; %for helping to understand
        sigma_n_Scaled(nxx,nyy)=kns2(count).*Sigma_N_ESA(nxx,nyy); 
    end  
end
sigma_Deno_scaled=Sigma_SN-sigma_n_Scaled;
figSigma2=figure;imshow(sigma_Deno_scaled,[-0.0015  0.007]);
colorbar('fontsize',22);

%% calculate the balancing factor(kpb(count,ii))
% calculate the balance values of the inter-swath boundaries from near to far range side,
% adjacent the fore sub-swath and then calculate the balance values in the next inter-swath.
sigma_n_Mod=sigma_n_Scaled;
kpb0=zeros(1,sWnum);
ytemp=zeros(1,sWnum);
[rangx,rangy]=size(sigma_n_Mod);
ytemp_before=0;
for count=2:sWnum   %count=3;ii=25
    nyy1=max(firstRangeSample(count-1,:)):min(lastRangeSample(count-1,:)); %the first block along the inter-swath
    nyy2=max(firstRangeSample(count,:)):min(lastRangeSample(count,:)); %the second block along the inter-swath
    if length(nyy1)<700 || length(nyy2)<700 %avoid the sub-swath too narrow.
        continue;
    end
    leng1=length(find(varss(count-1,:)<8*10^(-8))); %first, judge the homogeneous blocks using the threshold value of 8.0*10^-8 of variance
    leng2=length(find(varss(count,:)<8*10^(-8)));
    if leng1<3 && leng2<3 %first, judge the homogeneous blocks. if there is little homogeneous regions, turn to the Balance_inhomogeneous.
        InhomogeneousBalance; % calling function: inhomogeneousBalance.m
    else  %there are more homogeneous region.
        times=30; %set the iteration times.
        mm=0; %m is the iteration number
        while 1
            mm=mm+1;%m is the iteration number
            if mm>=times
                break;
            end
            nxx0=-199:0;kpb022=zeros(); %kpb022 is used to record the balance values in each two blocks
            for ii=1:ceil(rangx/200) 
                %------nxx is the azimuth width/lines of the block------------------------------------
                if ii*200<rangx
                    nxx=nxx0+200*ii;
                else
                    nxx=nxx(end)+1:rangx;
                end
                if length(nxx)<10
                    break;
                end
                %------only if there is one side is homogeneous------------------------------------------------------------
                if (varss(count-1,ii)<8*10^(-8) || varss(count,ii)<8*10^(-8))
                    %------1)select the local regions---------------------------------------------------------------------
                    if count-1==1 && varss(count-1,ii)<2*10^(-8)
                        bound1l=180;
                        bound2f=20;
                    else
                        bound1l=60;
                        bound2f=20;
                    end
                    sigmaRaw_temp1=Sigma_SN(nxx,min(lastRangeSample(count-1,:))-bound1l-20:min(lastRangeSample(count-1,:))-bound1l);
                    sigmaRaw_temp2=Sigma_SN(nxx,max(firstRangeSample(count,:))+bound2f:max(firstRangeSample(count,:))+bound2f+20);
                    
                    sigma_n_Mod_temp1=sigma_n_Mod(nxx,min(lastRangeSample(count-1,:))-bound1l-20:min(lastRangeSample(count-1,:))-bound1l);
                    sigma_n_Mod_temp2=sigma_n_Mod(nxx,max(firstRangeSample(count,:))+bound2f:max(firstRangeSample(count,:))+bound2f+20);
                    
                    ytemp1 =imresize(sigmaRaw_temp1,[length(nxx)/20,1],'box');  %calculate the box average, to pre-judge the ice-water conditions.
                    ytemp2 =imresize(sigmaRaw_temp2,[length(nxx)/20,1],'box'); 
                    
                    %------2)if the difference of the maxima of two sides is too large-----------------
                    if abs(max(max(ytemp2))-max(max(ytemp1)))>0.0045 ||isnan(max(max(ytemp2))) || isnan(max(max(ytemp1)))
                        kpb022(ii)=nan;
                    else
                    %------3)calculate the difference of local regions in two sides-----------------------------------------------
                        yy1=nanmean(nanmean(sigmaRaw_temp1-sigma_n_Mod_temp1)); %the mean values of local region.
                        yy2=nanmean(nanmean(sigmaRaw_temp2-sigma_n_Mod_temp2)); %the mean values of local region.
                        kpb022(ii)=yy2-yy1;  % the mean difference, i.e., the balance values.
                        if abs(kpb022(ii))>=2*10^(-3) %if the mean difference is larger than 0.002 
                            kpb022(ii)=nan;
                        end
                    end
                end %end the "if"
            end %end the "for"
            %------4)use the balance values in these homogeneous blocks to calculate the average balancing factor(kpb0(count))------------------- 
            kpb022(kpb022==0)=nan;
            if isnan(nanmean(kpb022))==0 %if there are homogeneous blocks with "not nan" values.
                kpb0(count)=kpb0(count)+nanmean(double(kpb022));
                disp(nanmean(kpb022));
            else
                if mm==1
                    kpb0(count)=kpb0(count-1); 
                else
                    kpb0(count)=0; 
                    break;
                end
            end
            %------5)make alignment at the inter-swath--------------------------------------- 
            firstAzimuthLineEW=firstAzimuthLine(count,:);
            firstAzimuthLineEW(find(isnan(firstAzimuthLineEW)))=[];
            for ii=1:length(firstAzimuthLineEW) %use kpb0 in each scene in each sub-swath
                nyy=firstRangeSample(count,ii):lastRangeSample(count,ii);
                nxx=firstAzimuthLine(count,ii):lastAzimuthLine(count,ii);
                sigma_n_Mod(nxx,nyy)=sigma_n_Scaled(nxx,nyy)+kpb0(count); 
            end
            %------6)if the balance values is smaller than 0.000001,stop the iteration--------- 
            if abs(nanmean(kpb022))<0.01*10^(-4)
                break;
            end
        end %while
    end 
end
% sigma_Deno_balanced=Sigma_SN-sigma_n_Mod;
% figure;imshow(sigma_Deno_balanced,[-0.0015,0.0065]);
% colorbar('fontsize',20,'color','k');

%-------7)global sigma field regression. only use the latter four sub-swaths----------------------------------------------
nyy=firstRangeSample(2,1):lastRangeSample(end,1);
sigma_n_balanced=sigma_n_Mod+nanmean(nanmean(Sigma_N_ESA(:,nyy)-sigma_n_Mod(:,nyy)));%sigmaBalanced is the scaled and balanced additive noise field
kpb2=kpb0+nanmean(nanmean(Sigma_N_ESA(:,nyy)-sigma_n_Mod(:,nyy)));%kpb2 is the optimal balancing factor

%----------additive noise subtraction---------------------------------------------------------------
sigma_Deno_balanced=Sigma_SN-sigma_n_balanced; %additive noise subtraction
figure;imshow(sigma_Deno_balanced,[-0.0015 0.0065]);
colorbar('fontsize',20,'color','k');

% close all


