%% Also using the image blocks for calculate the balancing factor of noise between sub-swath.
% 1)along the inter-swath boundary, dividing two sub-swaths into blocks, and calculate balancing factor in each two adjacent blocks.
% 2)use the variance factor to select the homogeneous blocks, then use the balancing factor of the homogeneous blocks to calculate the mean balancing factor.
% 3)global sigma field regression.
% For details of explanation, please refer to Section III, Part B "Determination of power balancing Factor" in the paper by Sun and Li (2020)
%% Subtract the scaled additive noise
close all;
sigma_n_Scaled=zeros(size(Sigma_SN));
sWnum=length(firstAzimuthLine(:,1)); %the number of sub-swath
for count=1:sWnum %use kns in each scene in each sub-swath
    firstAzimuthLineEW=firstAzimuthLine(count,:);
    firstAzimuthLineEW(find(isnan(firstAzimuthLineEW)))=[]; 
    for ii=1:length(firstAzimuthLineEW) 
        nyy=firstRangeSample(count,ii):lastRangeSample(count,ii); %the range width of the scene
        nxx=firstAzimuthLine(count,ii):lastAzimuthLine(count,ii); %the azimuth width of the scene
        % SigmaScaled(nxx,nyy)=kns2(count).*gggDS(nxx,nyy).*rsNoise(nxx,nyy)./cali(nxx,nyy).^2; %for helping to understand
        sigma_n_Scaled(nxx,nyy)=kns2(count).*Sigma_N_ESA(nxx,nyy); % .*10^10    2015֮ǰֵʱ10-7ηǲԵ
    end  
end
sigma_Deno_scaled=Sigma_SN-sigma_n_Scaled;
figSigma2=figure;imshow(sigma_Deno_scaled,[-0.0015  0.007]); impixelinfo;
colorbar('fontsize',22);


%% calculate the balancing factor(kpb(count,ii))
% calculate the balance values of the inter-swath boundaries from near to far range side,
% adjacent the fore sub-swath and then calculate the balance values in the next inter-swath.
%=====new setting: 20220904=============================
kpb0 = zeros(1,sWnum); kpb1 = zeros(1,sWnum); meann=nan(1,sWnum);
sigma_n_Mod=sigma_n_Scaled;
ytemp=zeros(1,sWnum);
[rangx,rangy]=size(sigma_n_Mod);
for count=1:sWnum  
    nyy=max(firstRangeSample(count,:))+100:min(lastRangeSample(count,:))-300; %the second block along the inter-swath
    if length(nyy)<700  %avoid the sub-swath too narrow.
        continue;
    end
    sigma_Deno_scaled=Sigma_SN - sigma_n_Mod;
    if count==1
        A=fspecial('average',[150,150]);
        sigmaRaw_temp11=imfilter(sigma_Deno_scaled(:,nyy),A);
        if nanmin(nanmin(sigmaRaw_temp11))<0.0003; meann(count)=nanmin(nanmin(sigmaRaw_temp11));  end
        continue;
    else
        A=fspecial('average',[100,100]);
        sigmaRaw_temp11=imfilter(sigma_Deno_scaled(:,nyy),A);
        if nanmin(nanmin(sigmaRaw_temp11))<0.0003; meann(count)=nanmin(nanmin(sigmaRaw_temp11)); end
    end
    meann(count-1)=meann(count-1)-kpb1(count-1);
    indx=find(~isnan(meann(1:count-1)));
    if ~isempty(indx) && count-indx(end)<=2
        kpb1(count)=meann(count)-meann(indx(end));
    else
        kpb1(count)=meann(count)-meann(count-1);
    end
    leng1=length(find(varss(count-1,:)<8*10^(-8))); %first, judge the homogeneous blocks using the threshold value of 8.0*10^-8 of variance
    leng2=length(find(varss(count,:)<8*10^(-8)));
    if ~isnan(kpb1(count)) && (leng1<10 || leng2<10)  
        firstAzimuthLineEW=firstAzimuthLine(count,:);
        firstAzimuthLineEW(find(isnan(firstAzimuthLineEW)))=[];
        for ii=1:length(firstAzimuthLineEW) %use kpb0 in each scene in each sub-swath
            nyy=firstRangeSample(count,ii):lastRangeSample(count,ii);
            nxx=firstAzimuthLine(count,ii):lastAzimuthLine(count,ii);
            sigma_n_Mod(nxx,nyy)=sigma_n_Scaled(nxx,nyy)+kpb1(count);
        end
        continue;
    end
    kpb1(count)=0; kpb0(count)=0; 
    BalancingParameter_calculation;
    kpb1(count)=kpb0(count);
end


%% -------7)global sigma field regression. only use the latter four sub-swaths----------------------------------------------
nyy=firstRangeSample(2,1):lastRangeSample(end,1);
sigma_n_balanced=sigma_n_Mod+nanmean(nanmean(Sigma_N_ESA(:,nyy)-sigma_n_Mod(:,nyy)));%sigmaBalanced is the scaled and balanced additive noise field
kpb2=kpb0+nanmean(nanmean(Sigma_N_ESA(:,nyy)-sigma_n_Mod(:,nyy)));%kpb2 is the optimal balancing factor

%----------------------------------------------------------------------
sigma_Deno_balanced=Sigma_SN-sigma_n_balanced; %additive noise subtraction
tt=imresize(sigma_Deno_balanced, 0.1, 'Box');
tt2=-0.00075-prctile(tt, 99.5, 'all');
if tt2>0
    sigma_Deno_balanced=sigma_Deno_balanced + tt2;
    sigma_n_balanced=sigma_n_balanced - tt2;
    kpb2=kpb2-tt2;
end

%----------additive noise subtraction---------------------------------------------------------------
figure;imshow(sigma_Deno_balanced,[-0.0015 0.0065]);
colorbar('fontsize',20,'color','k');


%% 
% for count=1:5
%     firstAzimuthLineEW=firstAzimuthLine(count,:);
%     firstAzimuthLineEW(find(isnan(firstAzimuthLineEW)))=[];%˴õı߽磬֮Ըƽ߽********
%     for ii=1:length(firstAzimuthLineEW)
%         nyy=firstRangeSample(count,ii):lastRangeSample(count,ii);%subswathľ±
%         nxx=firstAzimuthLine(count,ii):lastAzimuthLine(count,ii);
% %         sigma_n_Mod(nxx,nyy)=sigma_n_Scaled(nxx,nyy)+kpb1(count);  %źsigma0Ĺؼ
%         sigma_Deno_balanced(nxx,nyy)=sigma_Deno_scaled(nxx,nyy)-kpb2(count); 
%     end
% end
% 
% figure;imshow(sigma_Deno_balanced,[-0.0015 0.0065]);
% colorbar('fontsize',20,'color','k');

