function [ output_args ] =IPF28_2017_EW_Noiseremoval_HH(export_folder, File_path,HH_name )
%% ---------Acquire the annotation file path-----------------------------------------------------
tic 
Filename=HH_name;
S_filepath=strrep(File_path,'measurement','') ; %cut out 'string',add 'string'
S_filename=strrep(Filename,'.tiff','.');
tiff_path=[File_path, '/', Filename];

xmln=[S_filepath,'annotation\',S_filename,'xml'];%hv product annotation file
xml_c=[S_filepath,'annotation\calibration\calibration-',S_filename,'xml']; %hv calibration annotation file
xml_n=[S_filepath,'annotation\calibration\noise-',S_filename,'xml'];%hv noise annotation file
xml_m=[S_filepath,'manifest.safe'];%hv manifest.safe file


try
    DN_val=double(imread(tiff_path));%read image (.Tiff)
    DN_val(DN_val==0)=nan;%%Assign the border to be the value of "nan"
    [xf1,yf1]=size(DN_val);
    xmlDoc = xml_read(xmln);%read hv product annotation file
    xml_cc=xml_read(xml_c); %read hv calibration annotation file
    xml_nn=xml_read(xml_n);%read hv noise annotation file
    xmlMani = xml_read(xml_m);%read safe file
    for ii=1:length(xmlMani.metadataSection.metadataObject) %read the IPF version information
        if strcmp(xmlMani.metadataSection.metadataObject(ii).ATTRIBUTE.ID, 'processing')  
            IPFbanben=xmlMani.metadataSection.metadataObject(ii).metadataWrap.xmlData.safe_COLON_processing.safe_COLON_resource.processing.facility.software.ATTRIBUTE.version;
            AUX_CAL=xmlMani.metadataSection.metadataObject(ii).metadataWrap.xmlData.safe_COLON_processing.safe_COLON_resource.processing.resource(2).ATTRIBUTE.name;
            AUX_CALname=AUX_CAL(max(find(AUX_CAL=='/'))+1:end); %the name of needed auxiliary calibration file (aux_cal) 
            xmlauxcal=['AUX_CAL','\',AUX_CALname,'\data\',S_filename(1:4),'aux-cal.xml']; %the aux_cal files need to be downloaded from the website: https://qc.sentinel1.copernicus.eu/
            xml_AUX_CAL=xml_read(xmlauxcal);
            break;
        end
    end
catch
    disp('SAR safe file reading with error.');
    return;
end

%% ------Reading of longitude, latitude and incidence angle matrix to the full image-----------------
clear('lat','lon','lat2','lon2','rowline','colpixel');
n=1;m=1;
lat=zeros;lon=zeros;rowline=zeros;colpixel=zeros;   ele=zeros; inc=zeros;
ll=length(xmlDoc.geolocationGrid.geolocationGridPointList.geolocationGridPoint);
for ii=1:ll
    lat(n,m)=xmlDoc.geolocationGrid.geolocationGridPointList.geolocationGridPoint(ii).latitude;
    lon(n,m)=xmlDoc.geolocationGrid.geolocationGridPointList.geolocationGridPoint(ii).longitude;
    inc(n,m)=xmlDoc.geolocationGrid.geolocationGridPointList.geolocationGridPoint(ii).incidenceAngle;%ݲ֪Ƿãʱ
%     ele(n,m)=xmlDoc.geolocationGrid.geolocationGridPointList.geolocationGridPoint(ii).elevationAngle;%߶Ƚ
    rowline(n,m)=xmlDoc.geolocationGrid.geolocationGridPointList.geolocationGridPoint(ii).line+1;
    colpixel(n,m)=xmlDoc.geolocationGrid.geolocationGridPointList.geolocationGridPoint(ii).pixel+1;
    if ii<ll
        if rowline(n,m)~=xmlDoc.geolocationGrid.geolocationGridPointList.geolocationGridPoint(ii+1).line+1%ǰвһ
            n=n+1;
            m=1;
        else 
            m=m+1;
        end
    end
end

%if the longitude is across 180 degree
if max(max(lon))>0 && min(min(lon))<0 && abs(max(max(lon))-180)<5 && abs(min(min(lon))-(-180)<5)
    lon=rem(360+lon,360);% change its range to be [0,360] degree.
%     lon2=griddata(rowline,colpixel,lon,nX,nY,'cubic');%interpolation
% else  %if the longitude is not across 180 degree,direct interpolation                    
%     lon2=griddata(rowline,colpixel,lon,nX,nY,'cubic');  %first interpolation
% %     lon2=rem(360+lon2,360); %then convert the longitude to the range [0,360]. Also can not convert.
end


%% interpolation of the incidence angle.
nxx=1:1:xf1;nyy=1:1:yf1;
[nY,nX]=meshgrid(nyy,nxx);
inc2=griddata(rowline,colpixel,inc,nX,nY,'cubic');%ȫֵcubic,߶Ƚ


%% ----------Interpolation of calibration vector--------------------------
leng=length(xml_cc.calibrationVectorList.calibrationVector);
azimuthXc=zeros();azimuthYc=zeros();cali11=zeros();
for ii=1:leng
    azimuthXcc=xml_cc.calibrationVectorList.calibrationVector(ii).line;   
    azimuthYcc=xml_cc.calibrationVectorList.calibrationVector(ii).pixel;
    azimuthXc(ii,1:azimuthYcc.ATTRIBUTE.count)=azimuthXcc+1;%صλôӣ0,0ʼmatlab±1ʼãԼ1
    azimuthYc(ii,1:azimuthYcc.ATTRIBUTE.count)=azimuthYcc.CONTENT+1;
    calitemp=xml_cc.calibrationVectorList.calibrationVector(ii).sigmaNought;   
    cali11(ii,1:azimuthYcc.ATTRIBUTE.count)=calitemp.CONTENT;
end
[rows,cols]=size(cali11);
[cx,cy]=meshgrid(1:1:rows,1:1:cols);
[cxx,cyy]=meshgrid(1:((rows-1)/(xf1-1)):rows,1:((cols-1)/(yf1-1)):cols);
cali1=interp2(cx,cy,cali11',cxx,cyy,'cubic');%interp2ֵٶȿ
cali=cali1';%cali¸,ʸȽйɣȫֵ׼ȷ
clear('azimuthXcc','azimuthYcc','azimuthXc','azimuthYc','calitemp','cali11','cx','cy','cxx','cyy','cali1');

%% ȡʸ  %2.9汾֮ǰ
% ȡʸ------------------------------------------------------------
clear azimuthXn;clear azimuthYn;
leng=length(xml_nn.noiseVectorList.noiseVector);
RangeXn=zeros();RangeYn=zeros();sigma0n10=zeros();
for ii=1:leng
    RangeXn(ii)=xml_nn.noiseVectorList.noiseVector(ii).line+1;%صλôӣ0,0ʼmatlab±1ʼãԼ1
    RangeYnn=xml_nn.noiseVectorList.noiseVector(ii).pixel;
    RangeYn(ii,1:RangeYnn.ATTRIBUTE.count)=RangeYnn.CONTENT+1;
    sigma011=xml_nn.noiseVectorList.noiseVector(ii).noiseLut;   
    sigma0n10(ii,1:RangeYnn.ATTRIBUTE.count)=sigma011.CONTENT;
end %2.9汾֮ǰ
% ͼܱ߽紦ʸĴ------------------------------------------------------------
clear('x','y');
[x,y]=find(sigma0n10==0);
if isempty(y)==0 %0ֵ
    for i=2:length(y) %noiseе0ֵ
        if y(i)~=y(i-1) %ͬһ
            sigma0n1oneline=sigma0n10(:,y(i-1));
            index=find(sigma0n1oneline==0);%һΪ0ĵλ
            sigma0n1oneline(index)=[];%ȥ0ֵ
            xx=RangeXn;%˴ֱȡxxΪΪĲֵҪ
            xx2=xx(index);
            xx(index)=[];%x(m1):x(m2)
            if length(sigma0n1oneline)<=10
                disp('߽');
            else
                sigma0n10(index,y(i-1))=interp1(xx,sigma0n1oneline,xx2,'pchip');
                disp(sigma0n10(index,y(i-1)));%
            end
        end
    end
end
sigma0n1=sigma0n10;
% % Ծʸֱȫֵ˷ǰһ£------------------------------------------------------------
% clear rsNoise;
% nxx=1:1:xf1;nyy=1:1:yf1;
% [nY,nX]=meshgrid(nyy,nxx);
% [xxf,yyf]=size(RangeYn);
% RangenX=repmat(RangeXn,yyf,1)';
% rsNoise=griddata(RangenX,RangeYn,sigma0n1,nX,nY,'cubic');%ֵȫֵ
% clear('RangenX','RangenY','nxx','nyy','nX','nY');

%------Ϊ֮ͬı߽紦Ǳ߽ǶģS1Ʒ˵ļҲͬNESZϴ-------------------
%------ԸÿsceneطΧֵ----------------------------
% Ծֵ---------------------------------------------------
rsNoise=zeros();
sWnum=length(xmlDoc.imageAnnotation.processingInformation.inputDimensionsList.inputDimensions);
for count=1:sWnum %ÿsuswathڵcompletenoise
    leng=length(xmlDoc.swathMerging.swathMergeList.swathMerge(count).swathBoundsList.swathBounds);%leng>1ʱswathmegingVarying Optimal Range Cut Lineleng=1ʱswathmegingConstant Optimal Range Cut Line
    for ii=1:leng
        clear('firstAzimuthLine','firstRangeSample','lastAzimuthLine','lastRangeSample');
        firstRangeSample=xmlDoc.swathMerging.swathMergeList.swathMerge(count).swathBoundsList.swathBounds(ii).firstRangeSample+1;
        lastRangeSample=xmlDoc.swathMerging.swathMergeList.swathMerge(count).swathBoundsList.swathBounds(ii).lastRangeSample+1;
        firstAzimuthLine=xmlDoc.swathMerging.swathMergeList.swathMerge(count).swathBoundsList.swathBounds(ii).firstAzimuthLine+1;
        lastAzimuthLine=xmlDoc.swathMerging.swathMergeList.swathMerge(count).swathBoundsList.swathBounds(ii).lastAzimuthLine+1;
       
        clear('x','x1','x2','index1','index2','index11','index22','index3','index4');
        [x1,index11]=sort(abs(RangeXn-firstAzimuthLine));%ҳcalisuswathĵһλķλߣindex(1)Ǹߵ±
        if RangeXn(index11(1))<=firstAzimuthLine
            index1=index11(1);
        else
            index1=index11(1)-1;%ʹķλȴsubswath
        end
        [x2,index22]=sort(abs(RangeXn-lastAzimuthLine));% ҳcalisuswathһλķλߣindex(1)Ǹߵ±
        if RangeXn(index22(1))<lastAzimuthLine
            index2=index22(1)+1;
        else
            index2=index22(1);%ʹķλȴsubswath
        end
        if index2-index1<=1 %subswathķλСһֱľʸһάֵsubswathλϵľʸ
            if x1(1)<x2(1)
                midAzsubsw=index11(1);%ȡķλ
            else
                midAzsubsw=index22(1);
            end
            clear('index3','index4','temp','rrsam');
            [x,index3]=sort(abs(RangeYn(midAzsubsw,:)-firstRangeSample));%firstRangeSamplelastRangeSampleод˵
            [x,index4]=sort(abs(RangeYn(midAzsubsw,:)-lastRangeSample));%subswathλСһʱEW߽ϣдλ
            rrsam=firstRangeSample:1:lastRangeSample;
            temp=interp1(RangeYn(midAzsubsw,index3(1):index4(1)),sigma0n1(midAzsubsw,index3(1):index4(1)),rrsam,'pchip');
            for jj=firstAzimuthLine:lastAzimuthLine
                rsNoise(jj,firstRangeSample:lastRangeSample)=temp;
            end
        elseif index2-index1==2  %subswathķλֻһֱʸһάֵsubswathλϵľʸ
            clear('index3','index4');
            midAzsubsw=ceil((index1+index2)/2);%ȡsubswathindex2-1ķλҾ߽λ
            index3=max(find(RangeYn(midAzsubsw,:)>0 & RangeYn(midAzsubsw,:)<=firstRangeSample)); %firstRangeSamplelastRangeSampleод˵
            index4=max(find(RangeYn(midAzsubsw,:)>0 & RangeYn(midAzsubsw,:)<=lastRangeSample));
            
            nx=RangeXn(index1:index2);ny=RangeYn(midAzsubsw,index3:index4);
            [nY,nX]=meshgrid(ny,nx);
            nxx=firstAzimuthLine:1:lastAzimuthLine;nyy=firstRangeSample:1:lastRangeSample;
            [nYY,nXX]=meshgrid(nyy,nxx);
            rsNoise(firstAzimuthLine:lastAzimuthLine,firstRangeSample:lastRangeSample)=griddata(nX,nY,sigma0n1(index1:index2,index3:index4),nXX,nYY,'cubic');%ֵ
            
        else
            clear('index3','index4','temp','sigma0n2','nx','ny','nxx','nyy','nX','nY','nXX','nYY');
            midAzsubsw=ceil((index1+index2)/2);%ȡsubswathindex2-1ķλҾ߽λ
            index3=max(find(RangeYn(midAzsubsw,:)>0 & RangeYn(midAzsubsw,:)<=firstRangeSample));%firstRangeSamplelastRangeSampleод˵
            index4=find(RangeYn(midAzsubsw,:)>0 & RangeYn(midAzsubsw,:)<=lastRangeSample, 1, 'last' );
            sigma0n2=zeros(size(sigma0n1(index1:index2,index3:index4)));
            for mm=index3:index4
                nx=zeros(1,length(RangeXn(index1:index2)));
                nx(1,1)=firstAzimuthLine;
                nx(1,2:end-1)=RangeXn(index1+1:index2-1);%ֻȡ԰subswathڵķλ
                nx(1,end)=lastAzimuthLine;
                temp=interp1(nx(1,2:end-1),sigma0n1(index1+1:index2-1,mm)',nx,'pchip');%plot(temp);
                sigma0n2(:,mm-index3+1)=temp';
            end
            ny=RangeYn(midAzsubsw,index3:index4);
            [nY,nX]=meshgrid(ny,nx);
            nxx=firstAzimuthLine:1:lastAzimuthLine;nyy=RangeYn(midAzsubsw,index3):RangeYn(midAzsubsw,index4);
            [nYY,nXX]=meshgrid(nyy,nxx);
            rsNoise(firstAzimuthLine:lastAzimuthLine,RangeYn(midAzsubsw,index3):RangeYn(midAzsubsw,index4))=griddata(nX,nY,sigma0n2,nXX,nYY,'cubic');%ֵ
        end
    end
end
clear('RangeYnn','sigma011','midAzsubsw','rrsam','temp','nx','ny','nxx','nyy','nX','nY','nXX','nYY','azLine','noiseAzimuthLut','azNoise11','azNoise22','azxx','swathWide');
clear('firstAzimuthLine','firstRangeSample','lastAzimuthLine','lastRangeSample');

%% EWľ߽,˴Ϊ˿burstͼֱȡֵ߽
% sWnum=length(xmlDoc.imageAnnotation.processingInformation.inputDimensionsList.inputDimensions);
% firstRangeSample=double(sWnum+1);lastRangeSample=double(sWnum);
% firstRangeSample(1)=0;
% for count=1:sWnum
%     summm=0;
%     leng=length(xmlDoc.swathMerging.swathMergeList.swathMerge(count).swathBoundsList.swathBounds);%leng>1ʱswathmegingVarying Optimal Range Cut Lineleng=1ʱswathmegingConstant Optimal Range Cut Line
%    for ii=1:leng
%        lastRangeSam=xmlDoc.swathMerging.swathMergeList.swathMerge(count).swathBoundsList.swathBounds(ii).lastRangeSample;
%        summm=summm+lastRangeSam;   %˴swathmergingԿSentinel-1_Product_SpecificationļswathBoundsList
%    end
%    lastRangeSample(count)=floor(summm/leng);%˴ѡƽֵΪEW߽,עxmlǴ0ģmatlabǴ1
%    firstRangeSample(count+1)=lastRangeSample(count)+1;%firstRangeSamplelastRangeSampleΪ±ʹʱҪ1 
% end
% firstRangeSample=firstRangeSample+1;%Ϊ±
% lastRangeSample=lastRangeSample+1;
% clear('summm','lastRangeSam');

%% scolopping gain,naz,faz,ta,nburst,tfb,tovl,tb,tovr,tburst,ka,ks,kt,vs,f,radarWavelen,steerAngle,gAAEP,gdsgDS
%------------------tburst--------------------------------------------------------------------------------------------------------------------------
sWnum=length(xmlDoc.imageAnnotation.processingInformation.inputDimensionsList.inputDimensions);%naznum,swathĸone naz per swath
naz=zeros(sWnum);
for count=1:sWnum
    naz(count)=xmlDoc.imageAnnotation.processingInformation.inputDimensionsList.inputDimensions(count).numberOfInputLines;%naz,ڼTfbķλߵĿ
end
faz=xmlDoc.imageAnnotation.imageInformation.azimuthFrequency;%faz,ڼTfbķλȡƵ
aPnum=length(xmlDoc.antennaPattern.antennaPatternList.antennaPattern);
%nburst=aPnum/(sWnum*1.0);%nburst,burstĿ,ֵ׼ȷ
firstlinetimeorig=xmlDoc.imageAnnotation.imageInformation.productFirstLineUtcTime;%ȡһλʱжϺʱǷ0
firstlinetime=str2double(firstlinetimeorig(12:13))*3600+str2double(firstlinetimeorig(15:16))*60+str2double(firstlinetimeorig(18:end));%ʱתΪֵ
lastlinetimeorig=xmlDoc.imageAnnotation.imageInformation.productLastLineUtcTime;
if strcmp(lastlinetimeorig(6:7),firstlinetimeorig(6:7))==1 && strcmp(lastlinetimeorig(9:10),firstlinetimeorig(9:10))==1%жϴʱta0֮Ƿһ£Ƿ
    lastlinetime=str2double(lastlinetimeorig(12:13))*3600+str2double(lastlinetimeorig(15:16))*60+str2double(lastlinetimeorig(18:end));%ʱתΪֵ
else
    lastlinetime=(str2double(lastlinetimeorig(12:13))+24)*3600+str2double(lastlinetimeorig(15:16))*60+str2double(lastlinetimeorig(18:end));%0㣬ֻ轫hour24
end
m=1;ta=zeros();
for ii=1:aPnum  %ii=1; 
   ewwhich=xmlDoc.antennaPattern.antennaPatternList.antennaPattern(ii).swath;
   n=str2double(ewwhich(3));%ʾEW
   temp=xmlDoc.antennaPattern.antennaPatternList.antennaPattern(ii).azimuthTime;%ta,azimuthtime of first burst line,ַҪ{},ʱʽΪ2018-08-02T20:16:17.440192
   if strcmp(temp(6:7),firstlinetimeorig(6:7))==1 && strcmp(temp(9:10),firstlinetimeorig(9:10))==1%жϴʱta0֮Ƿһ£Ƿ
       ta(n,m)=str2double(temp(12:13))*3600+str2double(temp(15:16))*60+str2double(temp(18:end));%ʱתΪֵ
   else
       ta(n,m)=(str2double(temp(12:13))+24)*3600+str2double(temp(15:16))*60+str2double(temp(18:end));%0㣬ֻ轫hour24
   end
   if rem(ii,sWnum)==0 %˳ȡλʱֵnʾswathmʾburst
       m=m+1;
       disp(ii);
   end
end
clear('aPnum','firstlinetimeorig','lastlinetimeorig','ewwhich','n','temp');
%% ͼЧ
% ii=1;
% nyy=firstRangeSample(ii):lastRangeSample(ii);
% sigma0or1=DN_val(:,nyy)./cali(:,nyy);
% sigma0or2=nanmean(sigma0or1,2);
% sigma0or2(find(isnan(sigma0or2)))=[];%ɾֵ
% 
% timeinterval=xmlDoc.imageAnnotation.imageInformation.azimuthTimeInterval;
% taline=round(double(ta-firstlinetime)/timeinterval);
% %ytest=zeros(19);ytest=ytest+0.0355; %2018
% ytest=zeros(1,22);ytest=ytest+0.054;
% %ytest=[0.063,0.064,0.0655,0.0659,0.066,0.0655,0.0645,0.0635,0.0635,0.0633];
% figure;plot(sigma0or2);
% text(taline(1,:),ytest,'o');%hold on;plot(gDS(1,:).*0.01+0.05);
% %axis([3000,9000,0.031,0.037]); %2018
% axis([0,6000,0.048,0.057]);
%----------------------------------------------------------------------------------
% tfb=naz./(nburst*faz);
%timeinterval=xmlDoc.imageAnnotation.imageInformation.azimuthTimeInterval;%λʱעǰtbtcѾfirstlinetime,lastlinetime

nburstinput=length(xmlDoc.generalAnnotation.azimuthFmRateList.azimuthFmRate);%ͼburstδΪGRDǰburst
nburst=zeros();
tc=zeros();tb=zeros();tovl=zeros();
for n=1:sWnum %tb,tc,tovrÿswathÿburst
    nburst(n)=length(find(ta(n,:)~=0));%nburst(n)ΪGRDݺÿEWbursttatbtburst
    %linesofbu=(ta(n,3)-ta(n,2))*faz;
    tfb=naz(n)/((nburstinput)*faz);%burstδںǰ
    for m=2:nburst(n)
        tc(n,m)=ta(n,m-1)+tfb/2.0;%˴tcķǴ
        tovl(n,m-1)=tfb-(ta(n,m)-ta(n,m-1));
        tb(n,m)=ta(n,m)+tovl(n,m-1)/2.0;  
        %tovr(n,m)=tb(n,m)-tc(n,m);
        if tb(n,m)>lastlinetime %жһburst
            tb(n,m)=lastlinetime;
        end
        
    end
    tb(n,1)=ta(n,1)+tovl(n,1)/2.0;
    %tb(n,1)=tb(n,2)-(ta(n,2)-ta(n,1));%burstһtaһģ˵Ϊburst
    tc(n,1)=tb(n,1)-(ta(n,2)-ta(n,1))/2.0;%burstһtaһģ˵Ϊburst
    tc(n,nburst(n)+1)=ta(n,nburst(n))+tfb/2.0;%burstһtaһģ˵Ϊburst
    tb(n,nburst(n)+1)=lastlinetime;%!!!!!!!!!!!!!
end
%---ͼЧ-------------------------------------------------------------------------------
% clear ytest2;clear ytest3;
% timeinterval=xmlDoc.imageAnnotation.imageInformation.azimuthTimeInterval;
% tbline=floor(double(tb-firstlinetime)/timeinterval); %
% ytest2=ytest;
% tcline=round(double(tc-firstlinetime)/timeinterval);
% ytest3=ytest2-0.005;ytest3(23)=0.049;
% figure;plot(sigma0or2);
% text(taline(1,:),ytest,'+');text(tbline(1,:),ytest2,'*');text(tcline(1,:),ytest3,'o');%֤tbǶԵ
% axis([3000,6000,0.048,0.057]);
% %axis([3100,3700,0.055,0.07]);
% axis([2550,3200,0.055,0.07]);
% axis([0,1000,0.055,0.07]);

%-------tburstboundary---------------------------------------------------------------------------

%------------------ȡvsfks,ka,kt-------------------------------------------------------------------------------------------------------------------
steerRate=xmlDoc.generalAnnotation.productInformation.azimuthSteeringRate;%ȡλת
radarfre=xmlDoc.generalAnnotation.productInformation.radarFrequency;%ȡ״Ƶ
radarWavelen=299792458.0/radarfre;%״ﲨ
leng=length(xmlDoc.generalAnnotation.orbitList.orbit);
vs=zeros();azTime=zeros();
for ii=1:leng
    temptime=xmlDoc.generalAnnotation.orbitList.orbit(ii).time;
    azTime(ii)=str2double(temptime(12:13))*3600+str2double(temptime(15:16))*60+str2double(temptime(18:end));%ʱתΪֵ
    vsx=xmlDoc.generalAnnotation.orbitList.orbit(ii).velocity.x;%˴ѡùϢбемʱ̵ٶԴλ
    vsy=xmlDoc.generalAnnotation.orbitList.orbit(ii).velocity.y;
    vsz=xmlDoc.generalAnnotation.orbitList.orbit(ii).velocity.z;
    vs(ii)=sqrt(vsx^2+vsy^2+vsz^2);%ٶ
end
[x1,index11]=sort(abs(azTime-firstlinetime));%ҳcalisuswathĵһλķλߣindex(1)Ǹߵ±
if azTime(index11(1))<=firstlinetime
    index1=index11(1);
else
    index1=index11(1)-1;%ʹķλȴsubswath
end
[x2,index22]=sort(abs(azTime-lastlinetime));% ҳcalisuswathһλķλߣindex(1)Ǹߵ±
if azTime(index22(1))<lastlinetime
    index2=index22(1)+1;
else
    index2=index22(1);%ʹķλȴsubswath
end
clear('x1','index11','x2','index22','temptime','vsx','vsy','vsz');
vs=mean(vs(index1:index2));
ks=-2*vs*(steerRate*pi/180.0)/radarWavelen;%ksעⷽλתʵλҪdegree/sתΪrad/s    *pi/180.0
%--------------ÿswathмбʱ,antennaPatternListебʱ------------------------------------------------------------------------------------------------------------
tSR=zeros();
for ii=1:sWnum  
    ewwhich=xmlDoc.antennaPattern.antennaPatternList.antennaPattern(ii).swath;
    n=str2double(ewwhich(3));
    slantRangetime=xmlDoc.antennaPattern.antennaPatternList.antennaPattern(ii).slantRangeTime;%ȡantennaPatternListÿswathбʱslanttime
    num=length(slantRangetime.CONTENT); 
    tSR(n)=slantRangetime.CONTENT(floor(num/2));%ȡÿEWľмбʱ  +1
    disp(n);disp(num);
end
ka=zeros();
leng=length(xmlDoc.generalAnnotation.azimuthFmRateList.azimuthFmRate);
mm=1;
for nn=1:leng
    clear azTime;
    azTime=xmlDoc.generalAnnotation.azimuthFmRateList.azimuthFmRate(nn).azimuthTime;
    azTime=str2double(azTime(12:13))*3600+str2double(azTime(15:16))*60+str2double(azTime(18:end));%ʱתΪֵ
    if leng==nburst(count) %azimuthFmRateListĿպõnburstֱӶȡ
        t0=xmlDoc.generalAnnotation.azimuthFmRateList.azimuthFmRate(nn).t0; %ȡazimuthFMrateʽt0Ͷʽϵ
        c=xmlDoc.generalAnnotation.azimuthFmRateList.azimuthFmRate(nn).azimuthFmRatePolynomial;
        for count=1:sWnum
            ka(count,mm)=c.CONTENT(1)+c.CONTENT(2)*(tSR(count)-t0)+c.CONTENT(3)*(tSR(count)-t0)^2;
        end
        mm=mm+1;
    elseif leng<nburst(count) %azimuthFmRateListĿСnburstֱӶȡkaǰټһֵka(1)=ka(2)
        if nn==1
            mm=2;%kaӵڶΪСڵһһazTime>>firstlinetime,ֱkaǰټһֵ   
        end
        t0=xmlDoc.generalAnnotation.azimuthFmRateList.azimuthFmRate(nn).t0; %ȡazimuthFMrateʽt0Ͷʽϵ
        c=xmlDoc.generalAnnotation.azimuthFmRateList.azimuthFmRate(nn).azimuthFmRatePolynomial;
        for count=1:sWnum
            ka(count,mm)=c.CONTENT(1)+c.CONTENT(2)*(tSR(count)-t0)+c.CONTENT(3)*(tSR(count)-t0)^2;
            ka(count,1)=ka(count,2);
        end
        mm=mm+1;
    elseif azTime>=firstlinetime %azimuthFmRateListĿnburstжѡazTimeڵһλߵʱkakaĿ=nburst
        t0=xmlDoc.generalAnnotation.azimuthFmRateList.azimuthFmRate(nn).t0; %ȡazimuthFMrateʽt0Ͷʽϵ
        c=xmlDoc.generalAnnotation.azimuthFmRateList.azimuthFmRate(nn).azimuthFmRatePolynomial;
        for count=1:sWnum
            ka(count,mm)=c.CONTENT(1)+c.CONTENT(2)*(tSR(count)-t0)+c.CONTENT(3)*(tSR(count)-t0)^2;%tSR(count)is the mid-SlantRangetime of every swath
        end
        mm=mm+1;
    end
end
 
kt=-ka.*ks./(ks-ka);%ktĿnburst
clear('steerRate','radarfre','leng','tSR','mm','azTime','t0','c');
%------------------steerAngle,(t)-------------------------------------------------------------------------------------------------------------------
%-------------ֻÿburst˵steerAngleȻɲұԲֵõburstڵÿλߵ----------------------------------------------------------------
%-------------ԭΪÿburstڣktһģԦ(t)tburstɦ(t)õgAAEPʱҲԲֵ----------------------------------------------------------------
%-------------Կֱɦ(-tovr)(tovr)ֵ֮õĿֵ--------------------------------------------------------------------------------------------------
%-------------ؼǻȡÿburstڵķλĿ-------------------------------------------------------------------------------------------------------------------------
timeinterval=xmlDoc.imageAnnotation.imageInformation.azimuthTimeInterval;%λʱעǰtbtcѾfirstlinetime,lastlinetime
totallines=xmlDoc.imageAnnotation.imageInformation.numberOfLines;%עͼĳߴΪ8594x10392ÿswathĳȲͬ8594Ĳ־Ǻڱ
numPerburst=zeros();steerAngle=zeros();tburst=zeros();
for count=1:sWnum
    aztime=firstlinetime;ii=1;
    kt(count,nburst(count)+1)=kt(count,nburst(count));%һburstktǰһĴ棬burstһtaһģ˵Ϊburst
    for nn=1:nburst(count)+1
        num=1;
        tburst(count,2*nn-1)=aztime-tc(count,nn);%burstڵһλߵfocused burst time
        steerAngle(count,ii)=radarWavelen*kt(count,nn)*tburst(count,2*nn-1)/(2.0*vs);%burstڵһλߵת
        ii=ii+1;
        while((aztime-tb(count,nn))<timeinterval/1000.0)%aztime<=tb(count,nn)ʱ
            aztime=aztime+timeinterval;
            num=num+1;%ڼÿburstڵķλߵĿ
        end
        numPerburst(count,nn)=num-1;%¼ÿburstڵķλߵĿ
        tburst(count,2*nn)=aztime-timeinterval-tc(count,nn);%burstһλߵfocused burst timeʱaztimeѾһburstĵһλˣԼһ
        steerAngle(count,ii)=radarWavelen*kt(count,nn)*tburst(count,2*nn)/(2.0*vs);%burstһλߵת
        ii=ii+1;
    end
    disp(ii-1);disp(aztime);
end

s1=sum(numPerburst,2);%鿴ÿswathڵķλߵǷΪDN_val
steerAngle=steerAngle.*180.0./pi;%λתΪ
clear('aztime','s1');
%---------ȡgAAEP,steerAngle,ֵΪÿλ߲---------------------------------------------------------------------------------------------------------------------------
valuesAAEP=zeros();nn=1;
for ii=1:length(xml_AUX_CAL.calibrationParamsList.calibrationParams)
    swath=xml_AUX_CAL.calibrationParamsList.calibrationParams(ii).swath;
    polarisation=xml_AUX_CAL.calibrationParamsList.calibrationParams(ii).polarisation;
    if strcmp(swath(1:2),'EW')==1 && strcmp(polarisation,'HV')==1  %жǷEWģʽµHVļΪʽ޸Ĵ˴ж
        azAngleIncre=xml_AUX_CAL.calibrationParamsList.calibrationParams(ii).azimuthAntennaElementPattern.azimuthAngleIncrement;
        temp=xml_AUX_CAL.calibrationParamsList.calibrationParams(ii).azimuthAntennaElementPattern.values;
        leng=length(temp.CONTENT);
        valuesAAEP(nn,1:leng)=temp.CONTENT;%ȡAAEPģʽĽǶȼֵ
        nn=nn+1; %nnʾEW1~5
        if(swath(3)=='5')%ѾEWAAEP LUTֵͽѭ
            break;
        end
    end
end
steerAnglefix=zeros(size(steerAngle));
for count=1:sWnum
    for nn=1:nburst(count)+1
        steerAnglefix(count,2*nn-1)=fix(steerAngle(count,2*nn-1)/azAngleIncre)-1;%λ/Ƕȼȡburst߽ϵķλӦλ
        steerAnglefix(count,2*nn)=fix(steerAngle(count,2*nn)/azAngleIncre)+1;%ȡburstǰһλ򸺵ķһburstںһλķһʹֵȫburstڵķλ
    end
end
clear('swath','polarisation','temp','leng');
%---------õÿburstڰĲұеķλǺͶӦAAEPֵȻÿburstڲֵõҪĵϵֵyi=interp1(X, Y, xi, method)------------------------------------------------------

azlineAngle=zeros(sWnum,totallines);gAAEP=zeros(sWnum,totallines);
for count=1:sWnum
    numAAEP=length(valuesAAEP(count,:));%valuesAAEPĳΪ201мǸֵΪ0Ӧtburst=0angle=0AAEP=0ȻǰangleΪΪ
    midnum=(numAAEP+1)/2;%valuesAAEPԳƳȵмλãAAEPֵΪ0ĵط,101
    num=1;
    for nn=1:nburst(count)+1 %burst߽ϵķλӦAAEPֵ
        clear ('X','Y');Y=zeros(); %ÿһburstڵAAEPֵĳȶһҪ
        angle1=steerAnglefix(count,2*nn-1)*azAngleIncre;%burstĵһ߽緽λǣλΪ
        angle2=steerAnglefix(count,2*nn)*azAngleIncre;%burstĵڶ߽緽λǣλΪ
        X=angle1:azAngleIncre:angle2;%ÿburstڵǶ
        index1=midnum + steerAnglefix(count,2*nn-1);%burstĵһ߽緽λӦAAEP±,100-33=67valuesAAEP.CONTENT(67
        index2=midnum + steerAnglefix(count,2*nn); %burstĵer߽緽λӦAAEP±,-5~+5֤±
        for ii=index1:index2
            Y(ii-index1+1)=valuesAAEP(count,ii);%EWcountڵÿburstڵAAEPֵ
        end

        if numPerburst(count,nn)==0 %һburst
            break;
        else
            xi=linspace(steerAngle(count,2*nn-1),steerAngle(count,2*nn),numPerburst(count,nn));%burstڵĵһλߣڶλߣλߵĿע⣺(t)tburstԦ(t)ĵȼֵӦڷλߵĵȼֵֵazimuthtimeInterval
            yi=interp1(X, Y, xi,'linear');
            azlineAngle(count,num:num+numPerburst(count,nn)-1)=xi;
            gAAEP(count,num:num+numPerburst(count,nn)-1)=yi;%λ DB
            num=num+numPerburst(count,nn);
        end
    end
end
gds=power(10,gAAEP/20); %DB תΪ sigma0 Ϊ DB= 10 * log10sigma020Ϊ˫ 7.2.1
gDS=gds.^(-1); %˲ֵսֵDe-Scalloping Gain
clear('numAAEP','midnum','angle1','angle2','index1','index2','X','Y','xi','yi','num','count');

%----------ڶburstAAEPֵͼdescallopingͼ------------------------------------------------------------------
% oneburst=zeros;onegAAEP=zeros;onegDS=zeros;onegds=zeros;
% for count=1:sWnum %˴ȡtburstͼʱע
%     oneburst(count,1:numPerburst(count,2))=linspace(tburst(count,2*2-1),tburst(count,2*2),numPerburst(count,2));%ȡڶburstڵзλߵtburstʱ
%     onegAAEP(count,1:numPerburst(count,2))=gAAEP(count,numPerburst(count,1)+1:numPerburst(count,1)+numPerburst(count,2));%ȡÿEWĵһburstAAEPֵ
%     onegDS(count,1:numPerburst(count,2))=gDS(count,numPerburst(count,1)+1:numPerburst(count,1)+numPerburst(count,2));%ȡÿEWĵһburstgDSֵ
%     onegds(count,1:numPerburst(count,2))=gds(count,numPerburst(count,1)+1:numPerburst(count,1)+numPerburst(count,2));
% end
% oneburst=oneburst';
% onegAAEP=onegAAEP';
% onegDS=onegDS';
% onegds=onegds';
% oneburst(find(oneburst==0))=nan;
% onegAAEP(find(onegAAEP==0))=nan;
% onegDS(find(onegDS==0))=nan;
% onegds(find(onegDS==0))=nan;

%%----------ͼ------------------------------------------
% AAEPLUT=figure;
% plot(oneburst,onegAAEP);%ڶburstAAEPֵͼ,˫ֵ/2 TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
% axis equal;
% axis([-1.54,1.54,-2.0,0.2]);
% %axis([-1.54,1.54,-1.2,0.2]);
% title('AAEP values of 2nd burst from EW1 to EW5');xlabel('focused burst azimuth time--tburst(s)');ylabel('Azimuth Antenna Element Pattern(dB)');
% saveas(AAEPLUT,[new_folder,'\',tiff_path((max(idst)+1):(length(tiff_path)-65)),'_','AAEP LUTͼ','.png']);
% DeScal=figure;
% plot(oneburst,onegDS);%ڶburstscallopingͼ
% axis normal;
% axis([-1.54,1.54,0.95,1.3]);
% title('De-Scalloping Gain of 2nd burst from EW1 to EW5');xlabel('focused burst azimuth time--tburst(s)');ylabel('De-Scalloping Gain');
% saveas(DeScal,[new_folder,'\',tiff_path((max(idst)+1):(length(tiff_path)-65)),'_','De-Scalloping Gainͼ','.png']);
% %title('De-Scalloping Gain of 2th burst');xlabel('tburst(s)');ylabel('De-Scalloping Gain');
% clear ('oneburst','onegAAEP','onegDS');

%% EWÿsubswathı߽
sWnum=length(xmlDoc.imageAnnotation.processingInformation.inputDimensionsList.inputDimensions);
for count=1:sWnum
    leng(count)=length(xmlDoc.swathMerging.swathMergeList.swathMerge(count).swathBoundsList.swathBounds);%leng>1ʱswathmegingVarying Optimal Range Cut Lineleng=1ʱswathmegingConstant Optimal Range Cut Line
end
clear max;
ll=max(leng);
clear('firstAzimuthLine','firstRangeSample','lastAzimuthLine','lastRangeSample');
firstRangeSample=zeros;lastRangeSample=zeros;%ÿsubswathı߽飬ֱʾһߣһ
firstAzimuthLine=zeros;lastAzimuthLine=zeros;%ֱʾһλߣһλ
for count=1:sWnum
    leng=length(xmlDoc.swathMerging.swathMergeList.swathMerge(count).swathBoundsList.swathBounds);%leng>1ʱswathmegingVarying Optimal Range Cut Lineleng=1ʱswathmegingConstant Optimal Range Cut Line
    for ii=1:leng
        firstRangeSample(count,ii)=xmlDoc.swathMerging.swathMergeList.swathMerge(count).swathBoundsList.swathBounds(ii).firstRangeSample;
        lastRangeSample(count,ii)=xmlDoc.swathMerging.swathMergeList.swathMerge(count).swathBoundsList.swathBounds(ii).lastRangeSample;
        firstAzimuthLine(count,ii)=xmlDoc.swathMerging.swathMergeList.swathMerge(count).swathBoundsList.swathBounds(ii).firstAzimuthLine;
        lastAzimuthLine(count,ii)=xmlDoc.swathMerging.swathMergeList.swathMerge(count).swathBoundsList.swathBounds(ii).lastAzimuthLine;
    end   
    firstRangeSample(count,leng+1:ll)=nan;
    lastRangeSample(count,leng+1:ll)=nan;
    firstAzimuthLine(count,leng+1:ll)=nan;
    lastAzimuthLine(count,leng+1:ll)=nan;
end
firstRangeSample=firstRangeSample+1;%Ϊ±꣬1ʼ
lastRangeSample=lastRangeSample+1;
firstAzimuthLine=firstAzimuthLine+1;
lastAzimuthLine=lastAzimuthLine+1;

%% ÿEWڼscallopingչͼ
gggDS=zeros(size(DN_val));%ÿEWڵgDSչ
for count=1:sWnum
    leng=length(xmlDoc.swathMerging.swathMergeList.swathMerge(count).swathBoundsList.swathBounds);%leng>1ʱswathmegingVarying Optimal Range Cut Lineleng=1ʱswathmegingConstant Optimal Range Cut Line
    for ii=1:leng
        clear rswide;
        rswide=lastRangeSample(count,ii)-firstRangeSample(count,ii)+1;%subswathľ
        nyy=firstRangeSample(count,ii):lastRangeSample(count,ii);%subswathľ±
        nxx=firstAzimuthLine(count,ii):lastAzimuthLine(count,ii);
        %nnn1=gDS(count,nxx);plot(nnn1);
        gggDS1=repmat(gDS(count,nxx),rswide,1);
        gggDS(nxx,nyy)=gggDS1';%תúбʾλбʾ
    end
end
clear('rswide');

%% ȥڱ,ҵڱߵλ
DN_val(find(isnan(DN_val)))=0;
for ii=1:yf1
    id=find(DN_val(:,ii)<=20);
    if length(id)/xf1>0.15
        hhidy=ii;
    else
        hhidy=ii;
        break;
    end
end
for ii=1:xf1
    id=find(DN_val(ii,:)<=20);
    if length(id)/yf1>0.15
        hhidx=ii;
    else        
        hhidx=ii;
        break;
    end
end
for ii=xf1:-1:1
    id=find(DN_val(ii,:)<=20);
    if length(id)/yf1>0.15
        hhidxh=ii;
    else
        hhidxh=ii;
        break;      
    end
end
for ii=yf1:-1:1
    id=find(DN_val(:,ii)<=20);
    if length(id)/xf1>0.15
        hhidyh=ii;
    else
        hhidyh=ii;
        break;
    end
end
% Blackline=[idx,idxh,idy,idyh];
% save([new_folder,'\','ȥڱ4ֵ','.mat'],'Blackline');


%% denoising and calibration 
azNoise=gggDS;
vsi_noscaled=DN_val.^2./cali.^2-azNoise.*rsNoise./cali.^2; %꼰ȥδĤ
clearvars -EXCEPT hhidx hhidxh hhidy hhidyh tiff_path HH_name export_folder S_filepath new_folder vsi_noscaled rsNoise Sigma0S_dB ele2 inc2


%% correct the incidence angle effect.
% οJeo-wong Park2020ĺ£slopeȡ -0.21dB per degree, οѡ34.5
% refer to M?kynen, M. and Karvonen,2017, sigmanew=sigma0 + b1(theta_ref-theta)
% or Mahmud, M. S., et al., 2018, sigmanew=sigma0 - b1(theta-theta_ref),same as the above
Sigma0S_dB=vsi_noscaled;
Sigma0S_dB(vsi_noscaled<0.0001)=0.0001;  %ΪҪתΪdBλȶԸֵһ
Sigma0S_dB=10.*log10(Sigma0S_dB);

Sigma_newdB=Sigma0S_dB-0.21.*(34.5-inc2);
Sigma_new_HH=10.^(Sigma_newdB./10);

% % οZhang YuZhu Tingting, 2021еĹʽ
% % sigmanew= sigma0 * cos^2(theta_ref)/cos^2(theta),  linear unit
% % Sigma_ndir=repmat(vsi_noscaled(:, 1), 1, size(vsi_noscaled, 2)).* ((cos(inc2/180*pi)).^-0.21);
% Sigma_new_HH=vsi_noscaled.*((cos(34.5/180*pi)).^2)./((cos(inc2/180*pi)).^2);


%% ------save the result.----------------------------------
f2=figure; imshow(Sigma_new_HH, [0 0.18]); 
tt = colormap(gray(300));f2.Colormap= tt(40:end, :);  
colorbar('fontsize',11,'color','k'); 

tt = strfind(S_filepath, '_EW_');
Filename = S_filepath(tt-3:tt-3+66);
new_folder=[ export_folder, '/', Filename, '/'];
mkdir(new_folder);
print (f2,'-dpng','-r150',[new_folder,  Filename(end-3:end),'_HH.png']);
save([new_folder, Filename(end-3:end), '_HH.mat'], 'Sigma_new_HH', ...
                                   'hhidx', 'hhidxh', 'hhidy', 'hhidyh');


close all
toc