function [ output_args ] =IPF29_2018_EW_Noiseremoval_HH(export_folder, File_path, HH_name )
%% ---------Acquire the annotation file path-----------------------------------------------------
tic;
clc;close all;

Filename=HH_name;
S_filepath=strrep(File_path,'measurement','') ; %cut out 'string',add 'string'
S_filename=strrep(Filename,'.tiff','.');
tiff_path=[File_path, '/', Filename];

xmln=[S_filepath,'annotation\',S_filename,'xml'];%hv product annotation file
xml_c=[S_filepath,'annotation\calibration\calibration-',S_filename,'xml']; %hv calibration annotation file
xml_n=[S_filepath,'annotation\calibration\noise-',S_filename,'xml'];%hv noise annotation file
xml_m=[S_filepath,'manifest.safe'];%hv manifest.safe file

try
    DN_val=double(imread(tiff_path));%read the tiff image
    DN_val(DN_val==0)=nan;%Assign the border to be nan
    [xf1,yf1]=size(DN_val);
    xmlDoc = xml_read(xmln);%read product annotation file
    xml_cc=xml_read(xml_c); %read calibration annotation file
    xml_nn=xml_read(xml_n);%read noise annotation file
%     xmlMani = xml_read(xml_m);%read safe file
%     for ii=1:length(xmlMani.metadataSection.metadataObject) %read the IPF version information
%         if strcmp(xmlMani.metadataSection.metadataObject(ii).ATTRIBUTE.ID, 'processing')  
%             try
%                 IPFbanben=xmlMani.metadataSection.metadataObject(ii).metadataWrap.xmlData.safe_COLON_processing.safe_COLON_resource.processing.facility.software.ATTRIBUTE.version;  %2021֮ǰ
%             catch
%                 IPFbanben=xmlMani.metadataSection.metadataObject(ii).metadataWrap.xmlData.safe_COLON_processing.safe_COLON_resource.safe_COLON_processing.safe_COLON_facility.safe_COLON_software.ATTRIBUTE.version;  %2021֮
%             end
%             break;
%         end
%     end
catch
    disp('SAR safe file reading with error.');
    return;
end
%% ------Reading of longitude, latitude and incidence angle matrix to the full image-----------------
clear('lat','lon','lat2','lon2','rowline','colpixel');
n=1;m=1;
lat=zeros;lon=zeros;rowline=zeros;colpixel=zeros;   ele=zeros;  inc=zeros;
ll=length(xmlDoc.geolocationGrid.geolocationGridPointList.geolocationGridPoint);
for ii=1:ll
    lat(n,m)=xmlDoc.geolocationGrid.geolocationGridPointList.geolocationGridPoint(ii).latitude; %ΪγȵĶȡ˷ʱ䣬ûд
    lon(n,m)=xmlDoc.geolocationGrid.geolocationGridPointList.geolocationGridPoint(ii).longitude;
    inc(n,m)=xmlDoc.geolocationGrid.geolocationGridPointList.geolocationGridPoint(ii).incidenceAngle;%ݲ֪Ƿãʱ
%     ele(n,m)=xmlDoc.geolocationGrid.geolocationGridPointList.geolocationGridPoint(ii).elevationAngle;%߶Ƚ
    rowline(n,m)=xmlDoc.geolocationGrid.geolocationGridPointList.geolocationGridPoint(ii).line+1;
    colpixel(n,m)=xmlDoc.geolocationGrid.geolocationGridPointList.geolocationGridPoint(ii).pixel+1;
    if ii<ll
        if rowline(n,m)~=xmlDoc.geolocationGrid.geolocationGridPointList.geolocationGridPoint(ii+1).line+1%ǰвһ
            n=n+1;
            m=1;
        else %ͬһ
            m=m+1;
        end
    end
end

%if the longitude is across 180 degree
if max(max(lon))>0 && min(min(lon))<0 && abs(max(max(lon))-180)<5 && abs(min(min(lon))-(-180)<5)
    lon=rem(360+lon,360);% change its range to be [0,360] degree.
%     lon2=griddata(rowline,colpixel,lon,nX,nY,'cubic');%interpolation
% else  %if the longitude is not across 180 degree,direct interpolation                    
%     lon2=griddata(rowline,colpixel,lon,nX,nY,'cubic');  %first interpolation
% %     lon2=rem(360+lon2,360); %then convert the longitude to the range [0,360]. Also can not convert.
end


%% interpolation of the incidence angle.
nxx=1:1:xf1;nyy=1:1:yf1;
[nY,nX]=meshgrid(nyy,nxx);
inc2=griddata(rowline,colpixel,inc,nX,nY,'cubic');%ȫֵcubic,߶Ƚ


%% ----------Interpolation of calibration vector--------------------------
leng=length(xml_cc.calibrationVectorList.calibrationVector);
azimuthXc=zeros();azimuthYc=zeros();cali11=zeros();
for ii=1:leng
    azimuthXcc=xml_cc.calibrationVectorList.calibrationVector(ii).line;   
    azimuthYcc=xml_cc.calibrationVectorList.calibrationVector(ii).pixel;
    azimuthXc(ii,1:azimuthYcc.ATTRIBUTE.count)=azimuthXcc+1;%صλôӣ0,0ʼmatlab±1ʼãԼ1
    azimuthYc(ii,1:azimuthYcc.ATTRIBUTE.count)=azimuthYcc.CONTENT+1;
    calitemp=xml_cc.calibrationVectorList.calibrationVector(ii).sigmaNought;   
    cali11(ii,1:azimuthYcc.ATTRIBUTE.count)=calitemp.CONTENT;
end
[rows,cols]=size(cali11);
[cx,cy]=meshgrid(1:1:rows,1:1:cols);
[cxx,cyy]=meshgrid(1:((rows-1)/(xf1-1)):rows,1:((cols-1)/(yf1-1)):cols);
cali1=interp2(cx,cy,cali11',cxx,cyy,'cubic');%interp2ֵٶȿ
cali=cali1';%cali¸,ʸȽйɣȫֵ׼ȷ
clear('azimuthXcc','azimuthYcc','azimuthXc','azimuthYc','calitemp','cali11','cx','cy','cxx','cyy','cali1');

%% ȡʸ
% ȡʸ------------------------------------------------------------
clear azimuthXn;clear azimuthYn;
leng=length(xml_nn.noiseRangeVectorList.noiseRangeVector);
RangeXn=zeros();RangeYn=zeros();sigma0n1=zeros();
for ii=1:leng
    RangeXn(ii)=xml_nn.noiseRangeVectorList.noiseRangeVector(ii).line+1;%صλôӣ0,0ʼmatlab±1ʼãԼ1
    RangeYnn=xml_nn.noiseRangeVectorList.noiseRangeVector(ii).pixel;
    RangeYn(ii,1:RangeYnn.ATTRIBUTE.count)=RangeYnn.CONTENT+1;
    sigma011=xml_nn.noiseRangeVectorList.noiseRangeVector(ii).noiseRangeLut;   
    sigma0n1(ii,1:RangeYnn.ATTRIBUTE.count)=sigma011.CONTENT;
end %2.9汾
% ͼܱ߽紦ʸĴ------------------------------------------------------------
clear('x','y');
[x,y]=find(sigma0n1==0);
if isempty(y)==0 %0ֵ
    for i=2:length(y) %noiseе0ֵ
        if y(i)~=y(i-1) %ͬһ
            sigma0n1oneline=sigma0n1(:,y(i-1));
            index=find(sigma0n1oneline==0);%һΪ0ĵλ
            sigma0n1oneline(index)=[];%ȥ0ֵ
            xx=RangeXn;%˴ֱȡxxΪΪĲֵҪ
            xx2=xx(index);
            xx(index)=[];%x(m1):x(m2)
            if length(sigma0n1oneline)<=10
                disp('߽');
            else
                sigma0n1(index,y(i-1))=interp1(xx,sigma0n1oneline,xx2,'pchip');
                disp(sigma0n1(index,y(i-1)));%
            end
        end
    end
end
%-----Ծʸֱȫֵ⼸ǰ涨ֵĲֵһ-----------------------------------------------------------
%-----Ƕʸйɣʹֱӳ߽紦ҲǵȾ㣬ȫֵ׼ȷ--------------
%-----ʸĸǵȼģر߽紦ͼƴʱscene߽ƴӷӦ-------------------------------------------------------------------------------
nxx=1:1:xf1;nyy=1:1:yf1;
[nY,nX]=meshgrid(nyy,nxx);
[xxf,yyf]=size(RangeYn);
RangenX=repmat(RangeXn,yyf,1)';
rsNoise=griddata(RangenX,RangeYn,sigma0n1,nX,nY,'cubic');%ֵ
clear('RangenX','RangenY','nxx','nyy','nX','nY');  

%------Ϊ֮ͬı߽紦Ǳ߽ǶģS1Ʒ˵ļҲͬNESZϴ-------------------
%------ԸÿsceneطΧֵ-------------------------------------------------------------------
%ֵͷλ
clear('azNoise','azNoise11');
leng=length(xml_nn.noiseAzimuthVectorList.noiseAzimuthVector);
% azimuthXn=zeros();azimuthYn=zeros();sigma0n2=zeros();rsNoise=zeros();
azNoise=zeros();
for ii=1:leng %ÿsuswathڵcompletenoise
    clear('firstAzimuthLine','firstRangeSample','lastAzimuthLine','lastRangeSample');
    firstAzimuthLine=xml_nn.noiseAzimuthVectorList.noiseAzimuthVector(ii).firstAzimuthLine+1;%˴swathmergingԿSentinel-1_Product_SpecificationļswathBoundsList
    firstRangeSample=xml_nn.noiseAzimuthVectorList.noiseAzimuthVector(ii).firstRangeSample+1;
    lastAzimuthLine=xml_nn.noiseAzimuthVectorList.noiseAzimuthVector(ii).lastAzimuthLine+1;
    lastRangeSample=xml_nn.noiseAzimuthVectorList.noiseAzimuthVector(ii).lastRangeSample+1; %עͼеǴӣ0,0ʼģmatlabǴӣ1,1ʼ

    %----λֵ--------------------------------------------------------------
    azLine=xml_nn.noiseAzimuthVectorList.noiseAzimuthVector(ii).line;%ص㵽±Ҫ1
    noiseAzimuthLut=xml_nn.noiseAzimuthVectorList.noiseAzimuthVector(ii).noiseAzimuthLut;%
    noiseAzimuthLutval=noiseAzimuthLut.CONTENT;%
    if ischar(noiseAzimuthLutval)%ر𳤣matlabΪcharͣ
        noiseAzimuthLutval2=zeros();
        index1=zeros(1,azLine.ATTRIBUTE.count+1);
        index1(2:end-1)=find(isspace(noiseAzimuthLutval));
        index1(1)=0;index1(end)=length(noiseAzimuthLutval)+1;
        for jj2=1:length(index1)-1
            noiseAzimuthLutval2(jj2)=str2double(noiseAzimuthLutval(index1(jj2)+1:index1(jj2+1)-1));
        end
        noiseAzimuthLutval=noiseAzimuthLutval2;
    end
    azline2=azLine.CONTENT;
    if ischar(azline2)%ر𳤣matlabΪcharͣ
        azline2temp=zeros();
        index1=zeros(1,azLine.ATTRIBUTE.count+1);
        index1(2:end-1)=find(isspace(azline2));
        index1(1)=0;index1(end)=length(azline2)+1;
        for jj2=1:length(index1)-1
            azline2temp(jj2)=str2double(azline2(index1(jj2)+1:index1(jj2+1)-1));
        end
        azline2=azline2temp;
    end
    if azLine.ATTRIBUTE.count==1 %subswathֻһlinesubswathխֱȫֵ
        azNoise(firstAzimuthLine:lastAzimuthLine,firstRangeSample:lastRangeSample)=noiseAzimuthLutval;
    else
        azxx=firstAzimuthLine:1:lastAzimuthLine;
        azNoise11=interp1(azline2,noiseAzimuthLutval,azxx,'pchip');%طλ򣬽ֵÿ
        swathWide=lastRangeSample-firstRangeSample+1;
        azNoise22=repmat(azNoise11,swathWide,1);%sceneڽλƵÿУγ
        azNoise(firstAzimuthLine:lastAzimuthLine,firstRangeSample:lastRangeSample)=azNoise22';%תΪλǰں
    end
end

clear('firstAzimuthLine','firstRangeSample','lastAzimuthLine','lastRangeSample');
%ע⣬˴ҪnoiseAzimuthVectorListIPF2.9汾֮ǰûУ

%% ȥڱ,ҵڱߵλ
DN_val(find(isnan(DN_val)))=0;
for ii=1:yf1
    id=find(DN_val(:,ii)<=20);
    if length(id)/xf1>0.15
        hhidy=ii;
    else
        hhidy=ii;
        break;
    end
end
for ii=1:xf1
    id=find(DN_val(ii,:)<=20);
    if length(id)/yf1>0.15
        hhidx=ii;
    else        
        hhidx=ii;
        break;
    end
end
for ii=xf1:-1:1
    id=find(DN_val(ii,:)<=20);
    if length(id)/yf1>0.15
        hhidxh=ii;
    else
        hhidxh=ii;
        break;      
    end
end
for ii=yf1:-1:1
    id=find(DN_val(:,ii)<=20);
    if length(id)/xf1>0.15
        hhidyh=ii;
    else
        hhidyh=ii;
        break;
    end
end 


%% denoising and calibration 
vsi_noscaled=DN_val.^2./cali.^2-azNoise.*rsNoise./cali.^2; %꼰ȥδĤ
clearvars -EXCEPT hhidx hhidxh hhidy hhidyh tiff_path HH_name export_folder S_filepath new_folder vsi_noscaled rsNoise Sigma0S_dB ele2 inc2

%% correct the incidence angle effect.
% 1) οJeo-wong Park2020ĺ£slopeȡ -0.21dB per degree, οѡ34.5
% refer to M?kynen, M. and Karvonen,2017, sigmanew=sigma0 + b1(theta_ref-theta)
% or Mahmud, M. S., et al., 2018, sigmanew=sigma0 - b1(theta-theta_ref),same as the above
Sigma0S_dB=vsi_noscaled;
Sigma0S_dB(vsi_noscaled<0.0001)=0.0001;  %ΪҪתΪdBλȶԸֵһ
Sigma0S_dB=10.*log10(Sigma0S_dB);

Sigma_newdB=Sigma0S_dB-0.21.*(34.5-inc2);
Sigma_new_HH=10.^(Sigma_newdB./10);

% % 2) οZhang YuZhu Tingting, 2021еĹʽ
% % sigmanew= sigma0 * cos^2(theta_ref)/cos^2(theta),  linear unit
% % Sigma_ndir=repmat(vsi_noscaled(:, 1), 1, size(vsi_noscaled, 2)).* ((cos(inc2/180*pi)).^-0.21);
% Sigma_new_HH=vsi_noscaled.*((cos(34.5/180*pi)).^2)./((cos(inc2/180*pi)).^2);


%% ------save the result.----------------------------------
f2=figure; imshow(Sigma_new_HH, [0 0.18]); 
tt = colormap(gray(300));f2.Colormap= tt(40:end, :);  
colorbar('fontsize',11,'color','k'); 

tt = strfind(S_filepath, '_EW_');
Filename = S_filepath(tt-3:tt-3+66);
new_folder=[ export_folder, '/', Filename, '/'];
mkdir(new_folder);
print (f2,'-dpng','-r150',[new_folder,  Filename(end-3:end),'_HH.png']);
save([new_folder, Filename(end-3:end), '_HH.mat'], 'Sigma_new_HH', ...
                                   'hhidx', 'hhidxh', 'hhidy', 'hhidyh');


close all
toc

