function [ output_args ] = Judge_IPFbanben(export_folder, Sentinel_path, HV_name, HH_name )
close all; 

try
    S_filepath=strrep(Sentinel_path,'measurement','') ; %cut out 'string',add 'string'
    xml_m=[S_filepath,'manifest.safe']; % hv manifest.safe file
    xmlMani = xml_read(xml_m);%read .safe file
    for ii=1:length(xmlMani.metadataSection.metadataObject) %read the IPF version information
        if strcmp(xmlMani.metadataSection.metadataObject(ii).ATTRIBUTE.ID, 'processing')  
            try
                IPFbanben=xmlMani.metadataSection.metadataObject(ii).metadataWrap.xmlData.safe_COLON_processing.safe_COLON_resource.processing.facility.software.ATTRIBUTE.version;  % before year 2021
            catch
                IPFbanben=xmlMani.metadataSection.metadataObject(ii).metadataWrap.xmlData.safe_COLON_processing.safe_COLON_resource.safe_COLON_processing.safe_COLON_facility.safe_COLON_software.ATTRIBUTE.version;  % after year 2021
            end
            break;
        end
    end
catch
    return;
end
%% based on the IPF version, then select the scaloping noise removing method.
if IPFbanben>=2.9 
    IPF29_2018_EW_Noiseremoval_HV(export_folder, Sentinel_path, HV_name);
%     IPF29_2018_EW_Noiseremoval_HH(export_folder, Sentinel_path, HH_name);
else
    IPF28_2017_EW_Noiseremoval_HV(export_folder, Sentinel_path, HV_name); 
%     IPF28_2017_EW_Noiseremoval_HH(export_folder, Sentinel_path, HH_name )
end

