%% Subtract the scaled additive noise
sigma_n_Scaled=zeros(size(Sigma_SN));
sWnum=length(firstAzimuthLine(:,1)); %the number of sub-swath
for count=1:sWnum %use kns in each scene in each sub-swath
    firstAzimuthLineEW=firstAzimuthLine(count,:);
    firstAzimuthLineEW(find(isnan(firstAzimuthLineEW)))=[]; 
    for ii=1:length(firstAzimuthLineEW) 
        nyy=firstRangeSample(count,ii):lastRangeSample(count,ii); %the range width of the scene
        nxx=firstAzimuthLine(count,ii):lastAzimuthLine(count,ii); %the azimuth width of the scene
        % SigmaScaled(nxx,nyy)=kns2(count).*gggDS(nxx,nyy).*rsNoise(nxx,nyy)./cali(nxx,nyy).^2; %for helping to understand
        sigma_n_Scaled(nxx,nyy)=kns2(count).*Sigma_N_ESA(nxx,nyy); 
    end  
end
sigma_Deno_scaled=Sigma_SN-sigma_n_Scaled;
figSigma2=figure;imshow(sigma_Deno_scaled,[-0.0015  0.007]);
colorbar('fontsize',22);

%% calculate the kpb(1).only balance the EW1 to other four sub-swaths.
kpb0=zeros();
[rangx,rangy]=size(sigma_Deno_scaled);
if min(lastRangeSample(1,:))-200>1 && max(firstRangeSample(2,:))+100<rangy %avoid the EW1 is too narrow  
    temp1=nanmean(sigma_Deno_scaled(:,max(firstRangeSample(1,:)):min(lastRangeSample(1,:))));
    if max(isnan(temp1))<min(lastRangeSample(1,:))-200
        sigmaDenotemp1=sigma_Deno_scaled(:,min(lastRangeSample(1,:))-200:min(lastRangeSample(1,:))-160);
    else
        sigmaDenotemp1=sigma_Deno_scaled(:,min(lastRangeSample(1,:))-50:min(lastRangeSample(1,:))-10);
    end
    sigmaDenotemp2=sigma_Deno_scaled(:,max(firstRangeSample(2,:))+10:max(firstRangeSample(2,:))+50);
    
    ytemp1 =imresize(sigmaDenotemp1,[length(rangx)/20,length(rangy)/40],'box');
    ytemp2 =imresize(sigmaDenotemp2,[length(rangx)/20,length(rangy)/40],'box');
    if abs(max(max(ytemp2))-max(max(ytemp1)))>0.003
        kpb0(1)=nan;
    else
        yy1=nanmean(nanmean(sigmaDenotemp1));
        yy2=nanmean(nanmean(sigmaDenotemp2));
        kpb0(1)=yy1-yy2;
        if abs(kpb0(1))>=2*10^(-3)
            kpb0(1)=nan;
        end
    end
    if isnan(kpb0(1))
        kpb0(1)=0;
    end
end

%% use kpb0(1) to balance the first sub-swath and the others
sigma_n_balanced=sigma_n_Scaled;
count=1;
firstAzimuthLineEW=firstAzimuthLine(count,:);
firstAzimuthLineEW(find(isnan(firstAzimuthLineEW)))=[];
for ii=1:length(firstAzimuthLineEW)
    nyy=firstRangeSample(count,ii):lastRangeSample(count,ii);
    nxx=firstAzimuthLine(count,ii):lastAzimuthLine(count,ii);
    sigma_n_balanced(nxx,nyy)=sigma_n_Scaled(nxx,nyy)+kpb0(1); 
end
