%% multiplicative noise correction
% 1)make correction in each segmented blocks (of open water or low backscatter ice regions);
% 2)calculate the average parameters;
% 3)again use the average parameters to do noise correction, in all segmented blocks of open water or low backscatter ice regions;
% For details of explanation, please refer to Section III, Part C "Further removal of multiplicative noise" in the paper by Sun and Li (2020)
%% make a simple judgment for the image types
close all;
sigma_Deno_balanced=Sigma_SN-sigma_n_balanced; %the sigma after subtracting the additive noise
sigma_Deno_corrected=sigma_Deno_balanced;

if imgStyle~=1 %if it is not the normal ice-water image, no need to make correction.
    return;    %Please see "ScalingParameter_calculation".
end
%% make noise correction in each block
[rangx,rangy]=size(Sigma_SN);
sWnum=length(firstAzimuthLine(:,1)); %the number of sun-swaths
sigma_Deno_corrected=sigma_Deno_balanced;
diffratio=zeros(sWnum,ceil(rangx/200));logratio=zeros(sWnum,ceil(rangx/200));recorratio=zeros(sWnum,ceil(rangx/200));
conratio=zeros(sWnum,ceil(rangx/200));
nxx0=-199:0;
for count=1:sWnum  %in every sub-swath
    for ii=1:ceil(rangx/200) %in every segmented block
        %------nxx is the azimuth width/lines of the block------------------------------------
        if ii*200<rangx
            nxx=nxx0+200*ii; 
        else
            nxx=nxx(end)+1:rangx;
        end
        if length(nxx)<10
            break;
        end
        %------nyy is the range width/pixels of the block(i.e.,of the sub-swath)--------------------------------
        nyy=max(firstRangeSample(count,:))+5:max(lastRangeSample(count,:))-5; 
        if length(nyy)<600  
            count=count+1;
            break;
        end
        
        %--------0) Based on the SNNR and Sigma values of pixels at the boundary,---------------------------------
        %--------to judged if it's "open water" in the back-boundary of this block------------------------------
        clear('sigma0temp');
        sigmaDenotemp=sigma_Deno_corrected(nxx,nyy); 
        tempend=sigmaDenotemp(:,end-200:end); %take the values in the local 200*200 regions.
        sigmaNtemp=sigma_n_balanced(nxx,nyy); 
        tempend2=sigmaNtemp(:,end-200:end); %take the values in the local 200*200 regions.
        snnr=(tempend+tempend2)./tempend2; %snnr=(signal+noise)/noise
        
        ytemp1 =imresize(snnr,0.1,'box'); %the average snnr in the 10*10 solid window
        temp1=find( ytemp1>2);  %find the pixels of snnr values larger than 2.0
        ytemp2 =imresize(sigmaDenotemp,0.05,'box'); %the average sigma in the 20*20 solid window
        temp2=find( ytemp2> 0.003);  %find the pixels of sigma values larger than 0.003     
        
        if  length(temp1)<0.4*length(ytemp1(:))  && length(temp2)< 0.3*length(ytemp2(:))  %if the condition is met, it's "open water" in the back-boundary of this block
            %-------------------------------------------------------------------------------------------------------------
            clear('sigmaDenotemp');
            sigmaDenotemp=nanmean(sigma_Deno_corrected(nxx,nyy));
            sigmaDenotemp(sigmaDenotemp>max(sigmaDenotemp(100:end-100)))=max(sigmaDenotemp(100:end-100)); %remove the jump values.
            %---------remove the land,i.e.,the value "nan"-----------------------------------------------------------------
            clear nyytemp;
            temp1=find(isnan(sigmaDenotemp)); 
            if isempty(temp1)==0 && length(temp1)>=1
                temp2=zeros;mm2=2;
                for mm=1:length(temp1)-1
                    if temp1(mm+1)-temp1(mm)>1
                        temp2(mm2)=temp1(mm);
                        mm2=mm2+1;
                        temp2(mm2)=temp1(mm+1);
                        mm2=mm2+1;
                    end
                end
                temp2(1)= temp1(1); temp2(mm2)= temp1(end); nyytemp=1;
                for mm=1:2:length(temp2)-1
                    if temp2(mm)>150
                        nyytemp=[nyytemp,temp2(mm)-149:temp2(mm+1)];
                    else
                        nyytemp=[nyytemp,temp2(mm):temp2(mm+1)];
                    end
                    if temp2(mm+1)<length(nyy)-150
                        nyytemp=[nyytemp,temp2(mm+1)+1:temp2(mm+1)+149];
                    end
                end
                nyytemp(1)=[];
                sigmaDenotemp(nyytemp)=[];
                nyy(nyytemp)=[];
            end
            if length(nyy)<600 %if the sidth is too narrow
                continue;
            end
            %--------------------------------------------------------------------------------------
            %--------1) get the mean line---------------------------------------------------------
            temp2=smoothts(sigmaDenotemp(1:end),'e',30);
            temp3=smoothts(temp2,'e',20);
            sigmaDenotempfit=temp3;
            %--------2) get the profiles of deviation and NESZ(i.e. rsNoise)---------------------
            sigmaDev=sigmaDenotemp-sigmaDenotempfit;
            nESZ=nanmean(Sigma_NESZ(nxx,nyy));  %figure; plot(nESZ);
            %--------find the minimum position---------------------------------------------------
            nESZ(end-40:end)=nESZ(end-40);%remove the abnormal values
            indbottom=find(diff(sign(diff(nESZ(100:end-100))))==2)+1; %find the minimum position
            if isempty(indbottom) 
                indbottom=20;
            end
            planeA=indbottom(end)+100:indbottom(end)+200;%set the minimum region to be of width of 100 pixels.
            
            %--------3) calculate the difference factors and the ratio factors of the deviation-------
            bounDev=mean(abs(sigmaDev(end-140:end-40)));%get the boundary region to be of width of 100 pixels(end-140:end-40). the 40 is used to avoid jump values.
            temp=mean(sigmaDev(planeA));
            middleDev=mean(abs(sigmaDev(planeA)-temp));
            
            ratioDev=bounDev/middleDev;%ratio factor
            diffDev=bounDev-middleDev;%difference factor
            if  diffDev<0.000001 %the second judgment, to further judge the block is "open water" or not
                continue;      %if the difference factor<0.000001, the block is ice.
            end
            
            %--------4) calculate the difference factors and the ratio factors of the NESZ-----------------------------------------------
            rationESZ=mean(nESZ((end-100:end)))/mean(nESZ(planeA));
            diffnESZ=mean(nESZ((end-100:end)))-mean(nESZ(planeA));
            
            %--------5) scale and modify the NESZ profile---------------------------------------------------------------------------------
            nESZ1=abs(diffDev)/abs(diffnESZ).*nESZ;
            nESZ2=(nESZ1-min(nESZ1(1:end-100)))./max(nESZ1)+0.1;
            nESZ3=nESZ2.^abs(log(ratioDev)/log(rationESZ))+1/(2*ratioDev);
            
            %--------6) save the parameters-----------------------------------------------------------------------------------------------
            conratio(count,ii)=1/(2*ratioDev);
            diffratio(count,ii)=abs(diffDev)/abs(diffnESZ);
            logratio(count,ii)=abs(log(ratioDev)/log(rationESZ));
            if  (count==1 && logratio(count,ii)>1.5) || (count~=1 && logratio(count,ii)>0.9) %remove the inaccurate values
                logratio(count,ii)=nan;
                conratio(count,ii)=nan;
                diffratio(count,ii)=nan;
                continue;
            end
            
            %--------7) use the modified NESZ profile to correct the deviation, and make re-correction of the amplitude--------------------
            sigmaDev22=sigmaDev.*(1.0./nESZ3);
            sigmaDev33=sigmaDev22.*(mean(sigmaDev(sigmaDev>0))/mean(sigmaDev22(sigmaDev22>0))); %r_cor, recorrection parameter
            sigmaDevResult=sigmaDev33+sigmaDenotempfit;
            
            %--------8) extend the processing of profiles to the whole plane/surface of the block.-------------------------------------------------
            sigmaSurffit=repmat(sigmaDenotempfit,length(nxx),1);
            sigmaDevsurf=sigma_Deno_corrected(nxx,nyy)-sigmaSurffit;
            nESZsurf=repmat(nESZ3,length(nxx),1);
            
            sigmaDev22surf=sigmaDevsurf.*(1.0./nESZsurf); 
            temp=smoothts(sigmaDev(planeA),'e',10); subsk=sigmaDev(planeA)-temp;
            temp2=smoothts(sigmaDev22(planeA),'e',10); subsk2=sigmaDev22(planeA)-temp2;           
            recorratio(count,ii)=mean(subsk(subsk>0))/mean(subsk2(subsk2>0)); % r_cor, re-correction parameter
            
            sigmaDev33surf=sigmaDev22surf.*recorratio(count,ii);
            sigmaDevResultsurf=sigmaDev33surf+sigmaSurffit; 
            sigma_Deno_corrected(nxx,nyy)=sigmaDevResultsurf;
        end
    end
end

figure;imshow(sigma_Deno_corrected,[-0.0015,0.007]);
colorbar('fontsize',20,'color','k');

%% calculate the average values of the parameters
diffratio(find(diffratio==0))=nan;logratio(find(logratio==0))=nan;recorratio(find(recorratio==0))=nan;conratio(find(conratio==0))=nan;
conratio2=nanmean(conratio,2);
diffratio2=nanmean(diffratio,2);
logratio2=nanmean(logratio,2); 
recorratio2=nanmean(recorratio,2);
recorratio2(1)=recorratio2(1)-0.07; %because the roughness in EW1 is always larger than others,so lower the roughness a little. 

%% again use the average parameters to do noise correction 
[rangx,rangy]=size(Sigma_SN);
sWnum=length(firstAzimuthLine(:,1)); %the number of sun-swaths
sigma_Deno_corrected=sigma_Deno_balanced;
diffratio=zeros(sWnum,ceil(rangx/200));logratio=zeros(sWnum,ceil(rangx/200));recorratio=zeros(sWnum,ceil(rangx/200));
conratio=zeros(sWnum,ceil(rangx/200));
nxx0=-199:0;
for count=1:sWnum  %in every sub-swath
    if isnan(recorratio2(count))==1
        continue;
    end
    for ii=1:ceil(rangx/200) %in every segmented block
        %------nxx is the azimuth width/lines of the block------------------------------------
        if ii*200<rangx
            nxx=nxx0+200*ii; 
        else
            nxx=nxx(end)+1:rangx;
        end
        if length(nxx)<10
            break;
        end
        %------nyy is the range width/pixels of the block(i.e.,of the sub-swath)--------------------------------
        nyy=max(firstRangeSample(count,:))+5:max(lastRangeSample(count,:))-5; 
        if length(nyy)<600  
            count=count+1;
            break;
        end
        
        %--------0) Based on the SNNR and Sigma values of pixels at the boundary,---------------------------------
        %--------to judged if it's "open water" in the back-boundary of this block------------------------------
        clear('sigma0temp');
        sigmaDenotemp=sigma_Deno_corrected(nxx,nyy); 
        tempend=sigmaDenotemp(:,end-200:end); %take the values in the local 200*200 regions.
        sigmaNtemp=sigma_n_balanced(nxx,nyy); 
        tempend2=sigmaNtemp(:,end-200:end); %take the values in the local 200*200 regions.
        snnr=(tempend+tempend2)./tempend2; %snnr=(signal+noise)/noise
        
        ytemp1 =imresize(snnr,0.1,'box'); %the average snnr in the 10*10 solid window
        temp1=find( ytemp1>2);  %find the pixels of snnr values larger than 2.0
        ytemp2 =imresize(sigmaDenotemp,0.05,'box'); %the average sigma in the 20*20 solid window
        temp2=find( ytemp2> 0.003);  %find the pixels of sigma values larger than 0.003     
        
        if  length(temp1)<0.4*length(ytemp1(:))  && length(temp2)< 0.3*length(ytemp2(:))  %if the condition is met, it's "open water" in the back-boundary of this block
            %-------------------------------------------------------------------------------------------------------------
            clear('sigmaDenotemp');
            sigmaDenotemp=nanmean(sigma_Deno_corrected(nxx,nyy));
            sigmaDenotemp(sigmaDenotemp>max(sigmaDenotemp(100:end-100)))=max(sigmaDenotemp(100:end-100)); %remove the jump values.
            %---------remove the land,i.e.,the value "nan"-----------------------------------------------------------------
            clear nyytemp;
            temp1=find(isnan(sigmaDenotemp)); 
            if isempty(temp1)==0 && length(temp1)>=1
                temp2=zeros;mm2=2;
                for mm=1:length(temp1)-1
                    if temp1(mm+1)-temp1(mm)>1
                        temp2(mm2)=temp1(mm);
                        mm2=mm2+1;
                        temp2(mm2)=temp1(mm+1);
                        mm2=mm2+1;
                    end
                end
                temp2(1)= temp1(1); temp2(mm2)= temp1(end); nyytemp=1;
                for mm=1:2:length(temp2)-1
                    if temp2(mm)>150
                        nyytemp=[nyytemp,temp2(mm)-149:temp2(mm+1)];
                    else
                        nyytemp=[nyytemp,temp2(mm):temp2(mm+1)];
                    end
                    if temp2(mm+1)<length(nyy)-150
                        nyytemp=[nyytemp,temp2(mm+1)+1:temp2(mm+1)+149];
                    end
                end
                nyytemp(1)=[];
                sigmaDenotemp(nyytemp)=[];
                nyy(nyytemp)=[];
            end
            if length(nyy)<600 %if the width is too narrow
                continue;
            end
            %-------------------------------------------------------------------------------------------------------------
            %--------1) get the mean line---------------------------------------------------------------------------------
            temp2=smoothts(sigmaDenotemp(1:end),'e',30);
            temp3=smoothts(temp2,'e',20);
            sigmaDenotempfit=temp3;
            %--------2) get the profiles of deviation and NESZ(i.e. rsNoise)---------------------------------------------
            sigmaDev=sigmaDenotemp-sigmaDenotempfit;
            nESZ=nanmean(Sigma_NESZ(nxx,nyy));  %figure; plot(nESZ);
            
            %--------5) scale and modify the NESZ profile use the mean parameters---------------------------------------------------------------------------------
            nESZ1=nESZ.*diffratio2(count);
            nESZ2=(nESZ1-min(nESZ1(1:end-100)))./max(nESZ1)+0.1;
            nESZ3=nESZ2.^logratio2(count)+conratio2(count);
            
            %--------7) process the profiles in the whole plane/surface of the block.-------------------------------------------------
            sigmaSurffit=repmat(sigmaDenotempfit,length(nxx),1);
            sigmaDevsurf=sigma_Deno_corrected(nxx,nyy)-sigmaSurffit;
            nESZsurf=repmat(nESZ3,length(nxx),1);
            
            sigmaDev22surf=sigmaDevsurf.*(1.0./nESZsurf); 
            sigmaDev33surf=sigmaDev22surf.*recorratio2(count); %use the mean parameter "recorratio2"
            sigmaDevResultsurf=sigmaDev33surf+sigmaSurffit; 
            sigma_Deno_corrected(nxx,nyy)=sigmaDevResultsurf;
        end
    end
end

figure;imshow(sigma_Deno_corrected,[-0.0015,0.007]);
colorbar('fontsize',20,'color','k');

